#pragma once

#include "public.sdk/source/vst/vsteditcontroller.h"

namespace Steinberg {

class PdController : public Steinberg::Vst::EditController
{
public:
    PdController () = default;
    ~PdController () SMTG_OVERRIDE = default;

        /* creator */
    static Steinberg::FUnknown* createInstance (void* /*context*/)
    {
        return (Steinberg::Vst::IEditController*)new PdController;
    }

        /* IPluginBase */
    Steinberg::tresult PLUGIN_API initialize (Steinberg::FUnknown* context)
        SMTG_OVERRIDE;
    Steinberg::tresult PLUGIN_API terminate () SMTG_OVERRIDE;

        /* EditController */
    Steinberg::tresult PLUGIN_API setComponentState (Steinberg::IBStream* state)
        SMTG_OVERRIDE;
    Steinberg::IPlugView* PLUGIN_API createView (Steinberg::FIDString name)
        SMTG_OVERRIDE;
    Steinberg::tresult PLUGIN_API setParamNormalized
        (Steinberg::Vst::ParamID tag, Steinberg::Vst::ParamValue value)
            SMTG_OVERRIDE;
    Steinberg::tresult PLUGIN_API getParamStringByValue
        (Steinberg::Vst::ParamID tag,
            Steinberg::Vst::ParamValue valueNormalized,
                Steinberg::Vst::String128 string) SMTG_OVERRIDE;
    Steinberg::tresult PLUGIN_API getParamValueByString
        (Steinberg::Vst::ParamID tag, Steinberg::Vst::TChar* string,
            Steinberg::Vst::ParamValue& valueNormalized) SMTG_OVERRIDE;
    Steinberg::tresult PLUGIN_API notify(Vst::IMessage *message) SMTG_OVERRIDE;


    DEFINE_INTERFACES
    END_DEFINE_INTERFACES (EditController)
    DELEGATE_REFCOUNT (EditController)

    int needrenaming;   /* hack: poll this for parameters renamed */
protected:
};

} /* namespace Steinberg */
